"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = oauth;

var _client = _interopRequireDefault(require("../oauth/client"));

var _crypto = require("crypto");

var _logger = _interopRequireDefault(require("../../../lib/logger"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function oauth(_x, _x2, _x3) {
  return _oauth.apply(this, arguments);
}

function _oauth() {
  _oauth = _asyncToGenerator(function* (provider, csrfToken, authParams) {
    var _provider$version;

    var {
      callbackUrl
    } = provider;
    var client = (0, _client.default)(provider);

    if ((_provider$version = provider.version) === null || _provider$version === void 0 ? void 0 : _provider$version.startsWith('2.')) {
      var url = client.getAuthorizeUrl(_objectSpread(_objectSpread({}, authParams), {}, {
        redirect_uri: callbackUrl,
        scope: provider.scope,
        state: (0, _crypto.createHash)('sha256').update(csrfToken).digest('hex')
      }, provider.additionalAuthorizeParams));

      if (provider.authorizationUrl.includes('?')) {
        var parseUrl = new URL(provider.authorizationUrl);
        var baseUrl = "".concat(parseUrl.origin).concat(parseUrl.pathname, "?");
        url = url.replace(baseUrl, provider.authorizationUrl + '&');
      }

      return url;
    }

    try {
      var oAuthToken = yield client.getOAuthRequestToken(callbackUrl);
      return "".concat(provider.authorizationUrl, "?oauth_token=").concat(oAuthToken);
    } catch (error) {
      _logger.default.error('GET_AUTHORISATION_URL_ERROR', error);

      throw error;
    }
  });
  return _oauth.apply(this, arguments);
}